
-- REEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE!!!1!1!1- yes I know.


function ElementWaypoint:on_executed(instigator)
	if not self._values.enabled then
		return
	end

	if self._values.only_on_instigator and instigator ~= managers.player:player_unit() then
		ElementWaypoint.super.on_executed(self, instigator)

		return
	end

	if not self._values.only_in_civilian or managers.player:current_state() == "civilian" then
		local text = managers.localization:text(self._values.text_id)
	-- Vanilla code above
	
	
	-- Get if the waypoint is forbidden. True, False or Nil are used.
	local forbidden_wp = ignoreWP.Options:GetValue("forbid_" .. self._values.icon)
	
	if ignoreWP.Options:GetValue("invert_options") == true then
		forbidden_wp = not forbidden_wp
	end
	
	-- If the waypoint does exist in settings...
	if forbidden_wp then
		-- If the waypoint ID is not forbidden show it...
		if forbidden_wp == false then
			-- log("WPIgnored Allowed WP:", self._values.icon)
			managers.hud:add_waypoint(self._id, {
				distance = true,
				state = "sneak_present",
				present_timer = 0,
				text = text,
				icon = self._values.icon,
				position = self._values.position
			})
		end
		
	-- If the waypoint does not exist, check if we still want to show it...
	elseif ignoreWP.Options:GetValue("forbid_missing") == false then
		-- log("WPIgnored Allowed Unknown WP:", self._values.icon)
		managers.hud:add_waypoint(self._id, {
			distance = true,
			state = "sneak_present",
			present_timer = 0,
			text = text,
			icon = self._values.icon,
			position = self._values.position
		})
	end
	
	
	-- Vanilla code below
	elseif managers.hud:get_waypoint_data(self._id) then
		managers.hud:remove_waypoint(self._id)
	end

	ElementWaypoint.super.on_executed(self, instigator)
end